#!/usr/bin/perl
use strict;
use warnings;

my $infile=$ARGV[0];
my $outfile=$infile.".new";
open(IN, "<$infile") or die "Couldn't open file $infile, $!";
open(OUT, ">$outfile") or die "Couldn't open file $outfile, $!";
while(<IN>){
    print OUT $_;
    last if($_ =~/VERSION_BEGIN/);
}
close(IN);
$infile=$ARGV[1];
open(IN, "<$infile") or die "Couldn't open file $infile, $!";
my $first=1;
my $add="";
my $version_info="";
my $revno = "";
while(my $line = <IN>){
    chomp($line);
    if($first){
        $version_info = $line . ",\n";
        $first = 0;
    } else {
        $line =~ s/\"//g;
        $line =~ s/^\s+|\s+$//g;
    #    "revision-id: xxx.yyy@gmail.com-20150902100430-qabxhbgaio0802bw"
        if($line =~ /revision-id/){
            my @p = split("-",$line);
            splice @p , 0, 2;
            $line = "revision-id: " . join("-",@p);
        }
        if($line =~ /revno:/){
            my @p= split(":", $line);
            $revno = $p[1];
        }
        $version_info .= $add . "\"$line\\n\"\n";
        $add = "+";
    }
}
print OUT "    property var revno : $revno\n";
print OUT "    function show(){\n";
print OUT "       util.popupMessage(\n";
print OUT $version_info;
print OUT ")}}\n";
close(IN);
close(OUT);
