import QtQuick 2.4
import U1db 1.0 as U1db

/* New interface for options.
 * Currently it is just facade on DB logic.
 */
Item {

    function dbVersion() {
        return settingsDocument.contents.dbVersion
    }

    function setDbVersion(value) {
        var cont = settingsDocument.contents
        cont.dbVersion = value
        settingsDocument.contents = cont
    }
    function appHome() {
        return settingsDocument.contents.appHome
    }

    function setAppHome(value) {
        var cont = settingsDocument.contents
        cont.appHome = value
        settingsDocument.contents = cont
    }
    function navButtons() {
        return settingsDocument.contents.navButtons
    }
    function setNavButtons(value) {
        var cont = settingsDocument.contents
        cont.navButtons = value
        settingsDocument.contents = cont
    }
    function navButtonSize() {
        return settingsDocument.contents.navButtonSize
    }
    function setNavButtonSize(value) {
        var cont = settingsDocument.contents
        cont.navButtonSize = value
        settingsDocument.contents = cont
    }

    function gTLDfilter() {
        return settingsDocument.contents.gTLDfilter
    }
    function setgTLDfilter(value) {
        var cont = settingsDocument.contents
        cont.gTLDfilter = value
        settingsDocument.contents = cont
    }
    function langFilter() {
        return settingsDocument.contents.langFilter
    }
    function setLangFilter(value) {
        var cont = settingsDocument.contents
        cont.langFilter = value
        settingsDocument.contents = cont
    }
    function myFilter() {
        return settingsDocument.contents.myFilter
    }
    function setMyFilter(value) {
        var cont = settingsDocument.contents
        cont.myFilter = value
        settingsDocument.contents = cont
    }
    function allowPopup() {
        return settingsDocument.contents.allowPopup
    }
    function setAllowPopup(value) {
        var cont = settingsDocument.contents
        cont.allowPopup = value
        settingsDocument.contents = cont
    }
    function myPatterns() {
        return settingsDocument.contents.myPatterns
    }
    function setMyPatterns(value) {
        var cont = settingsDocument.contents
        cont.myPatterns = value
        settingsDocument.contents = cont
    }
    function useDownloadedPatterns() {
        return settingsDocument.contents.useDownloadedPatterns
    }
    function setUseDownloadedPatterns(value) {
        var cont = settingsDocument.contents
        cont.useDownloadedPatterns = value
        settingsDocument.contents = cont
    }
    function bmtrDownloaded() {
        return settingsDocument.contents.bmtrDownloaded
    }
    function setBmtrDownloaded(value) {
        var cont = settingsDocument.contents
        cont.bmtrDownloaded = value
        settingsDocument.contents = cont
    }
    function bmtrUseHttpReq() {
        return settingsDocument.contents.bmtrUseHttpReq
    }
    function setBmtrUseHttpReq(value) {
        var cont = settingsDocument.contents
        cont.bmtrUseHttpReq = value
        settingsDocument.contents = cont
    }
    function gtldDownloaded() {
        return settingsDocument.contents.gtldDownloaded
    }
    function setGtldDownloaded(value) {
        var cont = settingsDocument.contents
        cont.gtldDownloaded = value
        settingsDocument.contents = cont
    }
    function gTLD() {
        return settingsDocument.contents.gTLD
    }
    function setGTLD(value) {
        var cont = settingsDocument.contents
        cont.gTLD = value
        settingsDocument.contents = cont
    }
    function parseConf() {
        return settingsDocument.contents.parseConf
    }
    function setParseConf(value) {
        var cont = settingsDocument.contents
        cont.parseConf = value
        settingsDocument.contents = cont
    }
    function appLaunch() {
        return settingsDocument.contents.appLaunch
    }
    function setAppLaunch(value) {
        var cont = settingsDocument.contents
        cont.appLaunch = value
        settingsDocument.contents = cont
    }

    function dbLastUpdate() {
        return settingsDocument.contents.dbLastUpdate
    }

    function setDbLastUpdate(value) {
        var cont = settingsDocument.contents
        cont.setDbLastUpdate = value
        settingsDocument.contents = cont
    }
    function historyButton() {
        return settingsDocument.contents.historyButton
    }
    function setHistoryButton(value) {
        var cont = settingsDocument.contents
        cont.historyButton = value
        settingsDocument.contents = cont
    }

    U1db.Database {
        id: settingsDataBase
        path: "ShortsSettings"
    }

    U1db.Document {
        id: settingsDocument
        database: settingsDataBase
        docId: 'settingsDocument'
        create: true
        defaults: { "dbVersion" : latestDBVersion, "dbLastUpdate" : "", "appHome" : undefined, "navButtons" : true, "navButtonSize": 1
                   , "gTLDfilter" : true, "langFilter" : true, "myFilter" : "","allowPopup" : true
                   , "myPatterns" : "", "useDownloadedPatterns" : true, "bmtrDownloaded" : 0, "bmtrUseHttpReq" : false
                   , "gtldDownloaded" : 0, "gTLD" : [], "appLaunch" : 0
                   , "parseConf": '{"statLevel":2,"statUsers":true,"statGranularity":1,"logMaxRcrds":1000,"logLevel":2}'
                   , "historyButton" : true }
    }
} // QtObject
