.import "../config.js" as Conf

/* For internal usage in module.
 */
var categories=[
           {id:0,  name:i18n.tr("All Apps")},                  
           {id:1,  name:i18n.tr("Books & Comics")},            
           {id:2,  name:i18n.tr("Business")},                  
           {id:3,  name:i18n.tr("Communication")},                 
           {id:4,  name:i18n.tr("Developer Tools")},           
           {id:5,  name:i18n.tr("Education")},                 
           {id:6,  name:i18n.tr("Entertainment")},             
           {id:7,  name:i18n.tr("Finance")},
           {id:8,  name:i18n.tr("Food & Drink")},
           {id:9,  name:i18n.tr("Games")},
           {id:10, name:i18n.tr("Graphics")},
           {id:11, name:i18n.tr("Health & Fitness")},
           {id:12, name:i18n.tr("Lifestyle")},
           {id:13, name:i18n.tr("Media & Video")},
           {id:14, name:i18n.tr("Medical")},
           {id:15, name:i18n.tr("Music & Audio")},
           {id:16, name:i18n.tr("News & Magazines")},
           {id:17, name:i18n.tr("Personalisation")},
           {id:18, name:i18n.tr("Productivity")},
           {id:19, name:i18n.tr("Reference")},
           {id:20, name:i18n.tr("Science & Engineering")},
           {id:21, name:i18n.tr("Shopping")},
           {id:22, name:i18n.tr("Social Networking")},
           {id:23, name:i18n.tr("Sports")},
           {id:24, name:i18n.tr("Travel & Local")},
           {id:25, name:i18n.tr("Universal Access/Accessibility")},
           {id:26, name:i18n.tr("Utilities")},
           {id:27, name:i18n.tr("Weather")},           
          ]

function getWebappName(){
    return Conf.webappName;
}

function getAppTag(){
    return Conf.appTag;
}

function isDynamicAppTag(){
    if(Conf.appTag && !Conf.staticAppTag)return true;
    return false;
}

function appTagFilter(){
   if(!Conf.appTag) return false
   if(Conf.appTagFilterDef!=undefined) return Conf.appTagFilterDef
   return !isDynamicAppTag()
}

function isSuperPattern(){
    if (Conf.superPattern == true) {
        return true;
    }
    return false;
}

function positionId(pos){
    return ~~(pos + 0.0001)
}
function bookmarkId(pos){
    var d = pos - positionId(pos)
    if(d<.001)return undefined
    d = 100*d + 0.5
    return ~~d
}
//
//http://stackoverflow.com/questions/736513/how-do-i-parse-a-url-into-hostname-and-path-in-javascript
//
function getLocation(href) {
    var match = href.match(/^(https?\:)\/\/(([^:\/?#]*)(?:\:([0-9]+))?)(\/[^?#]*)(\?[^#]*|)(#.*|)$/);
    return match && {
        protocol: match[1],
        host: match[2],
        hostname: match[3],
        port: match[4],
        pathname: match[5],
        search: match[6],
        hash: match[7]
    }
}
//
// http://stackoverflow.com/questions/1026069/capitalize-the-first-letter-of-string-in-javascript
//
function capitalizeFirstLetter(str) {
    return str.charAt(0).toUpperCase() + str.slice(1);
}
function truncate(str, n){
    return str.length>n ? str.substr(0,n)+'...' : str;
}
function dnToLowerCase(href){
    if (!href.match('(http|https):\/\/(.*)')) {
        return '';
    }    
    if((href.match(/\//g) || []).length<3){
        href=href.replace(/\s/g, '')+"/"   
    }
    var parsed = getLocation(href)
    var l = parsed.protocol+'//'+parsed.host.toLowerCase()
    var o = parsed.protocol+'//'+parsed.host
    if(l != o) {
        href = href.replace(o,l)
    }
    return href
}

function getTranslation(href){
    var parsed = getLocation(href)
    var p = parsed.host.split('.')
    if(p.length>2 && p[0].length==2){
        return translateLocaleCode(p[0]);
    }
    p = parsed.pathname.split("/")
    if(p[1].length==2){
        return translateLocaleCode(p[1]);
    }
    return null;
}

function getNakedUrl(href){
//
// naked url <=> remove filename, hash and search
//
    var naked = href
    var parsed = getLocation(href)
    var filename=parsed.pathname.split("/").pop()
    if(filename && filename.length>0 && filename.match(/(.*)\.(.*)/)){
        naked=naked.replace(filename, ""); 
    }
    var s = parsed.search
    if(s && s.length>0){
        naked=naked.replace(s, ""); 
    }
    s = parsed.hash
    if(s && s.length>0){
        naked=naked.replace(s, ""); 
    }
    return naked
}

function getEquivalentUrls(href){
    var o=[]
    o.push(href)
//
// Equivalent urls <=> urls that open the same web page:
//
// http://www.example.com/index.xxx
// http://example.com/index.xxx 
// http://www.example.com/
// http://example.com/
//
    var parsed = getLocation(href)
    var host = parsed.host
    var href2 = null
    if(host.match(/^www\.(.*)/)){
        href2 = href.replace(/:\/\/www\./g, ':\/\/')
    } else if (!host.match(/^m\.(.*)/) && !host.match(/^mobile\.(.*)/)){
        href2 = href.replace(/:\/\//g, ':\/\/www\.')
    }
    if(href2)o.push(href2)
    var filename=parsed.pathname.split("/").pop()
    if(filename && filename.length>0 && filename.match(/^index\.(.*)/)){
        o.push(href.replace(filename, "")); 
        if(href2)o.push(href2.replace(filename, "")); 
    }
    return o
}
function getNonMobileUrl(href){
    var parsed = getLocation(href)
    var host = parsed.host
    if (host.match(/\.m\./)){
        href = href.replace(/\.m\./g, '.')
    } else if (host.match(/^m\.(.*)/)){
        href = href.replace(/:\/\/m\./g, ':\/\/')
    } else if (host.match(/^mobile\.(.*)/)){
        href = href.replace(/:\/\/mobile\./g, ':\/\/')
    }
    return href
}

function getDomain(url){
    return url.split('/').slice(0,3).join('/')
}

function doesMatch(url, pattern){
    if(!url || !pattern)return false
    if(checkPattern(getDomain(url),getDomain(pattern))){
        if(checkPattern(url, pattern)){
            return true
        }
    }
    return false;
}

function checkPattern(url, pattern){
    var tmpsearch = pattern.replace(/\*/g,'(.*)')
    var search = tmpsearch.replace(/^https\?:\/\//g, '(http|https):\/\/');
    if (url.match(search)) {
        return true;
    }
    if (Conf.superPattern == true) {
        search = search.replace(/:\/\/\(.\*\)\./g, ':\/\/');
        if (url.match(search)) {
            return true;
        }
    }
    return false;
}

function getCategories(){
    if(Conf.useCategories && Conf.useCategories.length>0){
        var o=[],i;
        for (i=0; i<Conf.useCategories.length; i++){
            o.push(categories[Conf.useCategories[i]])
        }
        return o;
    }
    return categories;
}

function getCategoryIds(){
    var o=[],i;
    if(Conf.useCategories && Conf.useCategories.length>0){
        for (i=0; i<Conf.useCategories.length; i++){
            o.push(categories[Conf.useCategories[i]].id)
        }
    } else {
        for (i=0; i<categories.length; i++){
            o.push(categories[i].id)
        }
    }
    return o;
}

function useAllCategories(){
   var u=getCategories()
   if (u.length == categories.length)return true;
   return false;
}

function getCategoryName(id){
    if(id>-1){
        var i
        var myCategories = getCategories()
        for (i=0; i<myCategories.length; i++){
            if(id==myCategories[i].id){
                return myCategories[i].name;
            }
        }
    }
    return i18n.tr("undefined");
}

function getCategoryId(id){
    if(id>0){
        var i
        var myCategories = getCategories()
        for (i=0; i<myCategories.length; i++){
            if(id==myCategories[i].id){
                return id;
            }
        }
    }
    return 0;
}

function getComboBoxExpandedHeight(items){
    var h = 50
    if(items<2){
        h=0
    } else if (items<7) {
        h=6.25*(items+1)
    }
    return  h;
}
function daysAgo(date){
    var currentdate = new Date();
    var d1 = new Date(date);
    var timeDiff = Math.abs(currentdate.getTime() - d1.getTime());
    var diffDays = Math.floor(timeDiff / (1000 * 3600 * 24)); 
//    console.log('daysAgo='+diffDays)
    return diffDays
}
//
// http://stackoverflow.com/questions/14636536/how-to-check-if-a-variable-is-an-integer-in-javascript
//
function isInt(value) {
  if (isNaN(value)) {
    return false;
  }
  var x = parseFloat(value);
  return (x | 0) === x;
}
//+ Jonas Raoni Soares Silva
//@ http://jsfromhell.com/string/wordwrap [rev. #2]

function wordWrap (str, m, b, c){
    var i, j, l, s, r;
    if(m < 1)
        return str;
    for(i = -1, l = (r = str.split("\n")).length; ++i < l; r[i] += s)
        for(s = r[i], r[i] = ""; s.length > m; r[i] += s.slice(0, j) + ((s = s.slice(j)).length ? b : ""))
            j = c == 2 || (j = s.slice(0, m + 1).match(/\S*(\s)?$/))[1] ? m : j.input.length - j[0].length
            || c == 1 && m || j.input.length + (j = s.slice(m).match(/^\S*/)).input.length;
    return r.join("\n");
};

// http://stackoverflow.com/questions/1584370/how-to-merge-two-arrays-in-javascript-and-de-duplicate-items
function arrayUnique(array) {
    var a = array.concat();
    for(var i=0; i<a.length; ++i) {
        for(var j=i+1; j<a.length; ++j) {
            if(a[i] === a[j])
                a.splice(j--, 1);
        }
    }
    return a;
};
// http://stackoverflow.com/questions/237104/array-containsobj-in-javascript
function contains(a, obj) {
    if(a){
        var i = a.length;
        while (i--) {
           if (a[i] === obj) {
               return true;
           }
        }
    }
    return false;
}

function splitLocale(locale){
    return locale.split('.')[0].split('@')[0].split('_')
}

function defaultDomains(loc){
    var a=[]
    var p=[]
    if(loc)p=splitLocale(loc)
    if(p[0]!='en')a.push(localeCodeToEnglish(p[0]))
    // ccTLD
    if(p[1]=='GB'){
        a.push(localeCodeToEnglish('uk'))
    } else {
        a.push(p[1].toLowerCase())
    }
    return a
}

function translateLocaleCode(loc){
    loc = remapLocaleCode(loc)
    if(loc.length!=2) return '';
    var t = localeCodeToEnglish(loc)
    if(!t){  
       t = localeCodeToEnglish(loc.toUpperCase())  
    } 
    return t;
}

function remapLocaleCode(loc) {
    var map ={"gr":"el", // greece
              "en":"xxx",
              "uk":"xxx"}   // "uk":"Ukrainian" but used also as "UNITED KINGDOM"
    return map[loc.toLowerCase()] || loc
}


// http://stackoverflow.com/questions/13917150/javascript-convert-en-us-and-similar-locale-codes-to-human-readable-strings

function localeCodeToEnglish(loc) {
    if (typeof loc !== 'string') return '';
    var parts = loc.split('-'),
        ISO639_1 = {"ab":"Abkhazian","aa":"Afar","af":"Afrikaans","ak":"Akan","sq":"Albanian","am":"Amharic","ar":"Arabic","an":"Aragonese","hy":"Armenian","as":"Assamese","av":"Avaric","ae":"Avestan","ay":"Aymara","az":"Azerbaijani","bm":"Bambara","ba":"Bashkir","eu":"Basque","be":"Belarusian","bn":"Bengali","bh":"Bihari languages","bi":"Bislama","nb":"Norwegian Bokmål","bs":"Bosnian","br":"Breton","bg":"Bulgarian","my":"Burmese","es":"Spanish","ca":"Valencian","km":"Central Khmer","ch":"Chamorro","ce":"Chechen","ny":"Nyanja","zh":"Chinese","za":"Zhuang","cu":"Old Slavonic","cv":"Chuvash","kw":"Cornish","co":"Corsican","cr":"Cree","hr":"Croatian","cs":"Czech","da":"Danish","dv":"Maldivian","nl":"Flemish","dz":"Dzongkha","en":"English","eo":"Esperanto","et":"Estonian","ee":"Ewe","fo":"Faroese","fj":"Fijian","fi":"Finnish","fr":"French","ff":"Fulah","gd":"Scottish Gaelic","gl":"Galician","lg":"Ganda","ka":"Georgian","de":"German","ki":"Kikuyu","el":"Greek","kl":"Kalaallisut","gn":"Guarani","gu":"Gujarati","ht":"Haitian Creole","ha":"Hausa","he":"Hebrew","hz":"Herero","hi":"Hindi","ho":"Hiri Motu","hu":"Hungarian","is":"Icelandic","io":"Ido","ig":"Igbo","id":"Indonesian","ia":"Interlingua","ie":"Occidental","iu":"Inuktitut","ik":"Inupiaq","ga":"Irish","it":"Italian","ja":"Japanese","jv":"Javanese","kn":"Kannada","kr":"Kanuri","ks":"Kashmiri","kk":"Kazakh","rw":"Kinyarwanda","ky":"Kyrgyz","kv":"Komi","kg":"Kongo","ko":"Korean","kj":"Kwanyama","ku":"Kurdish","lo":"Lao","la":"Latin","lv":"Latvian","lb":"Luxembourgish","li":"Limburgish","ln":"Lingala","lt":"Lithuanian","lu":"Luba-Katanga","mk":"Macedonian","mg":"Malagasy","ms":"Malay","ml":"Malayalam","mt":"Maltese","gv":"Manx","mi":"Maori","mr":"Marathi","mh":"Marshallese","ro":"Romanian","mn":"Mongolian","na":"Nauru","nv":"Navajo","nd":"North Ndebele","nr":"South Ndebele","ng":"Ndonga","ne":"Nepali","se":"Northern Sami","no":"Norwegian","nn":"Norwegian","ii":"Sichuan Yi","oc":"Occitan","oj":"Ojibwa","or":"Oriya","om":"Oromo","os":"Ossetic","pi":"Pali","pa":"Punjabi","ps":"Pushto","fa":"Persian","pl":"Polish","pt":"Portuguese","qu":"Quechua","rm":"Romansh","rn":"Rundi","ru":"Russian","sm":"Samoan","sg":"Sango","sa":"Sanskrit","sc":"Sardinian","sr":"Serbian","sn":"Shona","sd":"Sindhi","si":"Sinhalese","sk":"Slovak","sl":"Slovenian","so":"Somali","st":"Sotho, Southern","su":"Sundanese","sw":"Swahili","ss":"Swati","sv":"Swedish","tl":"Tagalog","ty":"Tahitian","tg":"Tajik","ta":"Tamil","tt":"Tatar","te":"Telugu","th":"Thai","bo":"Tibetan","ti":"Tigrinya","to":"Tonga","ts":"Tsonga","tn":"Tswana","tr":"Turkish","tk":"Turkmen","tw":"Twi","ug":"Uyghur","uk":"Ukrainian","ur":"Urdu","uz":"Uzbek","ve":"Venda","vi":"Vietnamese","vo":"Volapük","wa":"Walloon","cy":"Welsh","fy":"Western Frisian","wo":"Wolof","xh":"Xhosa","yi":"Yiddish","yo":"Yoruba","zu":"Zulu"},
        ISO3166_1 = {"AF":"AFGHANISTAN","AX":"ÅLAND ISLANDS","AL":"ALBANIA","DZ":"ALGERIA","AS":"AMERICAN SAMOA","AD":"ANDORRA","AO":"ANGOLA","AI":"ANGUILLA","AQ":"ANTARCTICA","AG":"ANTIGUA AND BARBUDA","AR":"ARGENTINA","AM":"ARMENIA","AW":"ARUBA","AU":"AUSTRALIA","AT":"AUSTRIA","AZ":"AZERBAIJAN","BS":"BAHAMAS","BH":"BAHRAIN","BD":"BANGLADESH","BB":"BARBADOS","BY":"BELARUS","BE":"BELGIUM","BZ":"BELIZE","BJ":"BENIN","BM":"BERMUDA","BT":"BHUTAN","BO":"BOLIVIA, PLURINATIONAL STATE OF","BQ":"BONAIRE, SINT EUSTATIUS AND SABA","BA":"BOSNIA AND HERZEGOVINA","BW":"BOTSWANA","BV":"BOUVET ISLAND","BR":"BRAZIL","IO":"BRITISH INDIAN OCEAN TERRITORY","BN":"BRUNEI DARUSSALAM","BG":"BULGARIA","BF":"BURKINA FASO","BI":"BURUNDI","KH":"CAMBODIA","CM":"CAMEROON","CA":"CANADA","CV":"CAPE VERDE","KY":"CAYMAN ISLANDS","CF":"CENTRAL AFRICAN REPUBLIC","TD":"CHAD","CL":"CHILE","CN":"CHINA","CX":"CHRISTMAS ISLAND","CC":"COCOS  ISLANDS","CO":"COLOMBIA","KM":"COMOROS","CG":"CONGO","CD":"CONGO, THE DEMOCRATIC REPUBLIC OF THE","CK":"COOK ISLANDS","CR":"COSTA RICA","CI":"CÔTE D'IVOIRE","HR":"CROATIA","CU":"CUBA","CW":"CURAÇAO","CY":"CYPRUS","CZ":"CZECH REPUBLIC","DK":"DENMARK","DJ":"DJIBOUTI","DM":"DOMINICA","DO":"DOMINICAN REPUBLIC","EC":"ECUADOR","EG":"EGYPT","SV":"EL SALVADOR","GQ":"EQUATORIAL GUINEA","ER":"ERITREA","EE":"ESTONIA","ET":"ETHIOPIA","FK":"FALKLAND ISLANDS","FO":"FAROE ISLANDS","FJ":"FIJI","FI":"FINLAND","FR":"FRANCE","GF":"FRENCH GUIANA","PF":"FRENCH POLYNESIA","TF":"FRENCH SOUTHERN TERRITORIES","GA":"GABON","GM":"GAMBIA","GE":"GEORGIA","DE":"GERMANY","GH":"GHANA","GI":"GIBRALTAR","GR":"GREECE","GL":"GREENLAND","GD":"GRENADA","GP":"GUADELOUPE","GU":"GUAM","GT":"GUATEMALA","GG":"GUERNSEY","GN":"GUINEA","GW":"GUINEA-BISSAU","GY":"GUYANA","HT":"HAITI","HM":"HEARD ISLAND AND MCDONALD ISLANDS","VA":"VATICAN CITY STATE","HN":"HONDURAS","HK":"HONG KONG","HU":"HUNGARY","IS":"ICELAND","IN":"INDIA","ID":"INDONESIA","IR":"IRAN, ISLAMIC REPUBLIC OF","IQ":"IRAQ","IE":"IRELAND","IM":"ISLE OF MAN","IL":"ISRAEL","IT":"ITALY","JM":"JAMAICA","JP":"JAPAN","JE":"JERSEY","JO":"JORDAN","KZ":"KAZAKHSTAN","KE":"KENYA","KI":"KIRIBATI","KP":"KOREA, DEMOCRATIC PEOPLE'S REPUBLIC OF","KR":"KOREA, REPUBLIC OF","KW":"KUWAIT","KG":"KYRGYZSTAN","LA":"LAO PEOPLE'S DEMOCRATIC REPUBLIC","LV":"LATVIA","LB":"LEBANON","LS":"LESOTHO","LR":"LIBERIA","LY":"LIBYA","LI":"LIECHTENSTEIN","LT":"LITHUANIA","LU":"LUXEMBOURG","MO":"MACAO","MK":"MACEDONIA, THE FORMER YUGOSLAV REPUBLIC OF","MG":"MADAGASCAR","MW":"MALAWI","MY":"MALAYSIA","MV":"MALDIVES","ML":"MALI","MT":"MALTA","MH":"MARSHALL ISLANDS","MQ":"MARTINIQUE","MR":"MAURITANIA","MU":"MAURITIUS","YT":"MAYOTTE","MX":"MEXICO","FM":"MICRONESIA, FEDERATED STATES OF","MD":"MOLDOVA, REPUBLIC OF","MC":"MONACO","MN":"MONGOLIA","ME":"MONTENEGRO","MS":"MONTSERRAT","MA":"MOROCCO","MZ":"MOZAMBIQUE","MM":"MYANMAR","NA":"NAMIBIA","NR":"NAURU","NP":"NEPAL","NL":"NETHERLANDS","NC":"NEW CALEDONIA","NZ":"NEW ZEALAND","NI":"NICARAGUA","NE":"NIGER","NG":"NIGERIA","NU":"NIUE","NF":"NORFOLK ISLAND","MP":"NORTHERN MARIANA ISLANDS","NO":"NORWAY","OM":"OMAN","PK":"PAKISTAN","PW":"PALAU","PS":"PALESTINIAN TERRITORY, OCCUPIED","PA":"PANAMA","PG":"PAPUA NEW GUINEA","PY":"PARAGUAY","PE":"PERU","PH":"PHILIPPINES","PN":"PITCAIRN","PL":"POLAND","PT":"PORTUGAL","PR":"PUERTO RICO","QA":"QATAR","RE":"RÉUNION","RO":"ROMANIA","RU":"RUSSIAN FEDERATION","RW":"RWANDA","BL":"SAINT BARTHÉLEMY","SH":"SAINT HELENA, ASCENSION AND TRISTAN DA CUNHA","KN":"SAINT KITTS AND NEVIS","LC":"SAINT LUCIA","MF":"SAINT MARTIN","PM":"SAINT PIERRE AND MIQUELON","VC":"SAINT VINCENT AND THE GRENADINES","WS":"SAMOA","SM":"SAN MARINO","ST":"SAO TOME AND PRINCIPE","SA":"SAUDI ARABIA","SN":"SENEGAL","RS":"SERBIA","SC":"SEYCHELLES","SL":"SIERRA LEONE","SG":"SINGAPORE","SX":"SINT MAARTEN","SK":"SLOVAKIA","SI":"SLOVENIA","SB":"SOLOMON ISLANDS","SO":"SOMALIA","ZA":"SOUTH AFRICA","GS":"SOUTH GEORGIA AND THE SOUTH SANDWICH ISLANDS","SS":"SOUTH SUDAN","ES":"SPAIN","LK":"SRI LANKA","SD":"SUDAN","SR":"SURINAME","SJ":"SVALBARD AND JAN MAYEN","SZ":"SWAZILAND","SE":"SWEDEN","CH":"SWITZERLAND","SY":"SYRIAN ARAB REPUBLIC","TW":"TAIWAN, PROVINCE OF CHINA","TJ":"TAJIKISTAN","TZ":"TANZANIA, UNITED REPUBLIC OF","TH":"THAILAND","TL":"TIMOR-LESTE","TG":"TOGO","TK":"TOKELAU","TO":"TONGA","TT":"TRINIDAD AND TOBAGO","TN":"TUNISIA","TR":"TURKEY","TM":"TURKMENISTAN","TC":"TURKS AND CAICOS ISLANDS","TV":"TUVALU","UG":"UGANDA","UA":"UKRAINE","AE":"UNITED ARAB EMIRATES","GB":"UNITED KINGDOM","US":"UNITED STATES","UM":"UNITED STATES MINOR OUTLYING ISLANDS","UY":"URUGUAY","UZ":"UZBEKISTAN","VU":"VANUATU","VE":"VENEZUELA, BOLIVARIAN REPUBLIC OF","VN":"VIET NAM","VG":"VIRGIN ISLANDS, BRITISH","VI":"VIRGIN ISLANDS, U.S.","WF":"WALLIS AND FUTUNA","EH":"WESTERN SAHARA","YE":"YEMEN","ZM":"ZAMBIA","ZW":"ZIMBABWE"};
    if (parts.length > 2) {
         console.log ('Unexpected number of segments ' + parts.length);
         return '';
    }
    if (parts.length > 1)
        return (ISO639_1[parts[0]] || parts[0]) + ', ' + (ISO3166_1[parts[1]] || parts[1]);
    if (parts.length > 0)
        return ISO639_1[parts[0]] || ISO3166_1[parts[0]];
    return '';
}
